# Opt-out

When Opt-out is enabled, the SDK stops sending all events.

## Configure at Initialization

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
val config = HackleConfig.builder()
    .optOutTracking(true)
    .build()

Hackle.initialize(applicationContext, YOUR_APP_SDK_KEY, config) {
    // SDK ready to use.
}
```

{% endtab %}

{% tab title="Java" %}

```java
HackleConfig config = HackleConfig.builder()
    .optOutTracking(true)
    .build();

HackleApp.initializeApp(getApplicationContext(), YOUR_APP_SDK_KEY, config, () -> {
    // SDK ready to use.
});
```

{% endtab %}
{% endtabs %}

## Runtime Opt-out Control

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
Hackle.setOptOutTracking(true)
Hackle.setOptOutTracking(false)
val isOptOut = Hackle.isOptOutTracking
```

{% endtab %}

{% tab title="Java" %}

```java
hackleApp.setOptOutTracking(true);
hackleApp.setOptOutTracking(false);
boolean isOptOut = hackleApp.isOptOutTracking();
```

{% endtab %}
{% endtabs %}

## Persistence Management

{% hint style="warning" %}
The Opt-out state changed at runtime is reset to the value configured in the initialization Config on app restart.

To persist the state across app restarts, you must implement your own save and restore logic.
{% endhint %}

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
fun saveOptOutState(context: Context, optOut: Boolean) {
    context.getSharedPreferences("hackle_prefs", Context.MODE_PRIVATE)
        .edit()
        .putBoolean("hackle_opt_out", optOut)
        .apply()
    Hackle.setOptOutTracking(optOut)
}

fun getOptOutConfig(context: Context): HackleConfig {
    val optOut = context.getSharedPreferences("hackle_prefs", Context.MODE_PRIVATE)
        .getBoolean("hackle_opt_out", false)
    return HackleConfig.builder()
        .optOutTracking(optOut)
        .build()
}
```

{% endtab %}

{% tab title="Java" %}

```java
void saveOptOutState(Context context, boolean optOut) {
    context.getSharedPreferences("hackle_prefs", Context.MODE_PRIVATE)
        .edit()
        .putBoolean("hackle_opt_out", optOut)
        .apply();
    hackleApp.setOptOutTracking(optOut);
}

HackleConfig getOptOutConfig(Context context) {
    boolean optOut = context.getSharedPreferences("hackle_prefs", Context.MODE_PRIVATE)
        .getBoolean("hackle_opt_out", false);
    return HackleConfig.builder()
        .optOutTracking(optOut)
        .build();
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/android/android-optout.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
